/* eslint-disable react/no-array-index-key */
/* eslint-disable react/jsx-no-leaked-render */
/* eslint-disable jsx-a11y/no-static-element-interactions */
import React, { useState, useEffect } from 'react';
import { getHandleValue } from '../utils/utils.js';
import { usePicker } from '../context.js';
import { low, high } from '../utils/formatters.js';
export const Handle = ({ left, i, setDragging, }) => {
    const { colors, selectedColor, squareWidth, defaultStyles, createGradientStr, } = usePicker();
    const isSelected = selectedColor === i;
    const leftMultiplyer = (squareWidth - 18) / 100;
    const setSelectedColor = (index) => {
        const newGradStr = colors?.map((cc, i) => ({
            ...cc,
            value: i === index ? high(cc) : low(cc),
        }));
        createGradientStr(newGradStr);
    };
    const handleDown = (e) => {
        e.stopPropagation();
        setSelectedColor(i);
        setDragging(true);
    };
    // const handleFocus = () => {
    //   setInFocus('gpoint')
    //   setSelectedColor(i)
    // }
    // const handleBlur = () => {
    //   setInFocus(null)
    // }
    return (React.createElement("div", { 
        // tabIndex={0}
        // onBlur={handleBlur}
        // onFocus={handleFocus}
        id: `gradient-handle-${i}`, onMouseDown: (e) => handleDown(e), style: {
            ...defaultStyles.rbgcpGradientHandleWrap,
            left: (left || 0) * leftMultiplyer,
        } },
        React.createElement("div", { style: {
                ...defaultStyles.rbgcpGradientHandle,
                ...(isSelected ? { boxShadow: '0px 0px 5px 1px rgba(86, 140, 245,.95)', border: '2px solid white' } : {}),
            } }, isSelected && (React.createElement("div", { style: {
                width: 5,
                height: 5,
                borderRadius: '50%',
                background: 'white',
            } })))));
};
const GradientBar = () => {
    const { currentColor, createGradientStr, colors, value, handleGradient, squareWidth } = usePicker();
    const [dragging, setDragging] = useState(false);
    // const [inFocus, setInFocus] = useState<string | null>(null)
    function force90degLinear(color) {
        return color.replace(/(radial|linear)-gradient\([^,]+,/, 'linear-gradient(90deg,');
    }
    const addPoint = (e) => {
        const left = getHandleValue(e);
        const newColors = [
            ...colors.map((c) => ({ ...c, value: low(c) })),
            { value: currentColor, left: left },
        ]?.sort((a, b) => a.left - b.left);
        createGradientStr(newColors);
    };
    // useEffect(() => {
    //   const selectedEl = window?.document?.getElementById(
    //     `gradient-handle-${selectedColor}`
    //   )
    //   if (selectedEl) selectedEl.focus()
    // }, [selectedColor])
    const stopDragging = () => {
        setDragging(false);
    };
    const handleDown = (e) => {
        if (dragging)
            return;
        addPoint(e);
        setDragging(true);
    };
    const handleMove = (e) => {
        if (dragging)
            handleGradient(currentColor, getHandleValue(e));
    };
    // const handleKeyboard = (e: any) => {
    //   if (isGradient) {
    //     if (e.keyCode === 8) {
    //       if (inFocus === 'gpoint') {
    //         deletePoint()
    //       }
    //     }
    //   }
    // }
    const handleUp = () => {
        stopDragging();
    };
    useEffect(() => {
        window.addEventListener('mouseup', handleUp);
        // window?.addEventListener('keydown', handleKeyboard)
        return () => {
            window.removeEventListener('mouseup', handleUp);
            // window?.removeEventListener('keydown', handleKeyboard)
        };
    });
    return (React.createElement("div", { style: {
            width: '100%',
            marginTop: 17,
            marginBottom: 4,
            position: 'relative',
        }, id: "gradient-bar" },
        React.createElement("div", { style: {
                height: 14,
                borderRadius: 10,
                width: squareWidth,
                backgroundImage: force90degLinear(value),
            }, onMouseDown: (e) => handleDown(e), onMouseMove: (e) => handleMove(e) }),
        colors?.map((c, i) => (React.createElement(Handle, { i: i, left: c.left, key: `${i}-${c}`, setDragging: setDragging })))));
};
export default GradientBar;
